<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroupType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroupType extends AbstractStructArrayBase
{
    /**
     * The FareGroupType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroupType[]
     */
    public $FareGroupType;
    /**
     * Constructor method for ArrayOfJP_FareGroupType
     * @uses ArrayOfJP_FareGroupType::setFareGroupType()
     * @param \StructType\JP_FareGroupType[] $fareGroupType
     */
    public function __construct(array $fareGroupType = array())
    {
        $this
            ->setFareGroupType($fareGroupType);
    }
    /**
     * Get FareGroupType value
     * @return \StructType\JP_FareGroupType[]|null
     */
    public function getFareGroupType()
    {
        return $this->FareGroupType;
    }
    /**
     * Set FareGroupType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupType[] $fareGroupType
     * @return \ArrayType\ArrayOfJP_FareGroupType
     */
    public function setFareGroupType(array $fareGroupType = array())
    {
        foreach ($fareGroupType as $arrayOfJP_FareGroupTypeFareGroupTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupTypeFareGroupTypeItem instanceof \StructType\JP_FareGroupType) {
                throw new \InvalidArgumentException(sprintf('The FareGroupType property can only contain items of \StructType\JP_FareGroupType, "%s" given', is_object($arrayOfJP_FareGroupTypeFareGroupTypeItem) ? get_class($arrayOfJP_FareGroupTypeFareGroupTypeItem) : gettype($arrayOfJP_FareGroupTypeFareGroupTypeItem)), __LINE__);
            }
        }
        $this->FareGroupType = $fareGroupType;
        return $this;
    }
    /**
     * Add item to FareGroupType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupType $item
     * @return \ArrayType\ArrayOfJP_FareGroupType
     */
    public function addToFareGroupType(\StructType\JP_FareGroupType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroupType) {
            throw new \InvalidArgumentException(sprintf('The FareGroupType property can only contain items of \StructType\JP_FareGroupType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FareGroupType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroupType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroupType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroupType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroupType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroupType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroupType
     */
    public function getAttributeName()
    {
        return 'FareGroupType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_FareGroupType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
